#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed Nov 10 22:36:41 2021

@author: li
"""
import torch
import torch.nn as nn
from torch.utils.data import Dataset

EPOCHS = 100
SAVE_NAME = './1'

# 1. define network ==================================================================


class NET(nn.Module):  
    def __init__(self):
        super(NET, self).__init__()
        self.L1 = nn.Linear(4,16)

    def forward(self,x):
        x = self.L1(x)
        return x

net = NET()

# 2. define dataloader ==================================================================

class Dateset(Dataset):
    def __init__(self, data, label):
        self.data_info = list()
        for idx, data in enumerate(data):
            _data = torch.tensor(data)
            _data = _data.to(torch.float32)
            self.data_info.append((_data,label[idx]))
        
    def __getitem__(self, index):
        data, label = self.data_info[index] 
        return data, label
        
    def __len__(self):
        return len(self.data_info)
    
#==========decimal to bcd encoder===========
data = list()
label = list()
#===========NAND gate=====================


#========================================
Dateset = Dateset(data,label)

train_loader = torch.utils.data.DataLoader(
    Dateset,
    batch_size=1,
    shuffle=True,
)


# 3. define loss and optimizer ===========================================================

criterion = nn.CrossEntropyLoss()
optimizer = torch.optim.SGD(      
    net.parameters(),  
    lr=0.1,
    momentum=0.9,
    weight_decay=5e-4,
    nesterov=True,
)

# 4. start to train ======================================================================

device = torch.device("cuda" if torch.cuda.is_available() else "cpu")

print("            =======  Training  ======= \n") 
for ep in range(1, EPOCHS + 1):
    train_loss =  correct = total = 0
    for idx, (inputs, targets) in enumerate(train_loader):
        inputs, targets = inputs.to(device), targets.to(device)
        outputs = net(inputs)
        loss = criterion(outputs, targets)
        optimizer.zero_grad()
        loss.backward()
        optimizer.step()
        train_loss += loss.item()
        total += targets.size(0)
        correct += torch.eq(outputs.argmax(dim=1), targets).sum().item()
        if (idx + 1) % 100 == 0 or (idx + 1) == len(train_loader):
            
            print(
                "   == step: [{:3}/{}] | loss: {:.3f} | acc: {:6.3f}%".format(
                    idx + 1,
                    len(train_loader),
                    train_loss / (idx + 1),
                    100.0 * correct / total,
                ))
print("\n            =======  Training Finished  ======= \n")

# net(torch.FloatTensor([1,1,0,1])).argmax(dim=0)
